"use strict";

const { Model } = require("objection");

module.exports = function ({ db }) {
	return class Alias extends Model {
		static tableName = "aliases";
		static idColumn = "alias";
	
		static get relationMappings() {
			return {
				item: {
					relation: Model.BelongsToOneRelation,
					modelClass: db.Item,
					join: { from: "aliases.itemId", to: "items.id" }
				}
			};
		};
	}
};
