"use strict";

const { Model } = require("objection");

module.exports = function ({ db }) {
	return class TaskResult extends Model {
		static tableName = "taskResults";
		static idColumn = [ "task", "itemId" ];
	
		static get relationMappings() {
			return {
				item: {
					relation: Model.BelongsToOneRelation,
					modelClass: db.Item,
					join: { from: "taskResults.itemId", to: "item.id" }
				}
			};
		};
	}
};
